Attribute VB_Name = "Module1"
Public slovnik() As String
Public abecedap() As String 'znaky ktere nejsou v anglicke abecede, nebo znaky ktere nechceme pouzivat jako oddelovace
Public fCesta As String 'cesta ke vstupnimu souboru
Public tCesta As String 'cesta ke vystupnimu souboru
Public fSoubor As String 'vstupni soubor
Public tSoubor As String 'vystupni soubor

Public Sub NactiSlovnik()
    Dim pp As Long, fr As Integer 'pomocne promenne
    pp = 0
    fr = FreeFile
    Open App.Path & "\Dict.txt" For Input As fr 'otevru soubor se slovnikem
        Do While Not EOF(fr) 'a dokud neni konec souboru
            ReDim Preserve slovnik(pp)
            Input #fr, slovnik(pp)  'Vezmu radku a strcim si ji do svyho slovniku (pole)
            If InStr(1, slovnik(pp), "/") <> 0 Then slovnik(pp) = Left(slovnik(pp), InStr(1, slovnik(pp), "/") - 1) 'Odstranim vse co nepatri ke slovu
            pp = pp + 1 'a jdu dal
        Loop
    Close fr
End Sub

Public Sub NactiVstup()
    Dim fr As Integer 'pomocna promenna pro praci se souborem
    Dim pp As String 'pomocna promenna pro nacitani textu ze souboru
    fr = FreeFile
    Open fCesta For Binary As fr
        fSoubor = Space(LOF(fr))
        Get #fr, , fSoubor 'text ze souboru ulozim do promenne fSoubor
    Close fr
End Sub

Public Sub Kontroluj() 'Tady prochazim slovo za slovem a kontroluju jestli neni ve slovniku pokud ne oznacim ho
    Dim s As Long
    s = 1
    For i = 2 To Len(fSoubor)
        If Not Pismeno(Mid(fSoubor, i, 1)) Then
            If veSlovniku(Right(Mid(fSoubor, s, i - s), Len(Mid(fSoubor, s, i - s)) - 1)) Then
                tSoubor = tSoubor & Mid(fSoubor, s, i - s)
            Else
                tSoubor = tSoubor & Left(Mid(fSoubor, s, i - s), 1) & "#" & Right(Mid(fSoubor, s, i - s), Len(Mid(fSoubor, s, i - s)) - 1)
            End If
            s = i
        End If
    Next i
    If Pismeno(Right(fSoubor, 1)) Then
        If veSlovniku(Right(fSoubor, Len(fSoubor) - s)) Then
            tSoubor = tSoubor & Mid(fSoubor, s, Len(fSoubor))
        Else
            tSoubor = tSoubor & Mid(fSoubor, s, 1) & "#" & Right(fSoubor, Len(fSoubor) - s)
        End If
    Else
        tSoubor = tSoubor & Right(fSoubor, 1)
    End If
    If Mid(tSoubor, 2, 1) = "#" And Pismeno(Left(tSoubor, 1)) Then tSoubor = Left(tSoubor, 1) & Right(tSoubor, Len(tSoubor) - 2)
    For i = 2 To Len(tSoubor)
        If Not Pismeno(Mid(tSoubor, i, 1)) Then
           If Not veSlovniku(Left(tSoubor, i - 1)) Then tSoubor = "#" & tSoubor
           Exit Sub
        End If
    Next i
    If Not veSlovniku(tSoubor) Then tSoubor = "#" & tSoubor
End Sub


Public Function Pismeno(par) As Boolean 'Zkontroluju zda parametr povazuji za pismeno(tj neni to oddelovac)
    If par >= "a" And par <= "z" Then Pismeno = True
    If par >= "A" And par <= "Z" Then Pismeno = True
    If IsNumeric(par) Then Pismeno = True
    For i = 0 To UBound(abecedap)
        If par = abecedap(i) Or Pismeno Then
            Pismeno = True
            Exit For
        End If
    Next i
End Function

Public Sub NactiAbecedu()
    Dim fr As Integer
    Dim pp As Long
    pp = 0
    fr = FreeFile
    Open App.Path & "\Z9_abeceda.txt" For Input As fr 'otevru soubor
        Do While Not EOF(fr)
            ReDim Preserve abecedap(pp)
            Input #fr, abecedap(pp)  'Nactu vsechny znaky ktere nejsou cisla nebo soucasti anglicke abecedy a presto je nechci pouzit jako oddelovace
            pp = pp + 1
        Loop
    Close fr
End Sub
Public Function veSlovniku(par) As Boolean 'Zjisti jestli je zadany parametr ve slovniku
    On Error Resume Next
    If IsNumeric(par) Then
        veSlovniku = True
        Exit Function
    End If
    If Asc(par) < 32 Then veSlovniku = True
    For i = 0 To UBound(slovnik)
        If par = slovnik(i) Then
            veSlovniku = True
            Exit For
        End If
    Next i
End Function

Public Sub UlozVystup() 'Ulozi vystupni soubor
    Dim fr As Integer
    fr = FreeFile
    Open tCesta For Output As #fr
        Print #fr, tSoubor
    Close fr
End Sub

